Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 26744)
@@ -1720,4 +1760,592 @@
 }
 /*}}}*/
+void       Tria::GetFractionGeometry(IssmDouble* weights, IssmDouble* pphi, int* ppoint1,IssmDouble* pfraction1,IssmDouble* pfraction2, bool* ptrapezeisnegative, IssmDouble* gl){/*{{{*/
+
+	/*Computeportion of the element that is grounded*/
+	bool               trapezeisnegative=true; //default value
+	int                point;
+	const IssmPDouble  epsilon= 1.e-15;
+	IssmDouble         f1,f2,phi;
+
+	/*Weights: */
+	Gauss* gauss=NULL;
+	IssmDouble loadweights_g[NUMVERTICES];
+	IssmDouble total_weight=0;
+
+	_assert_(!xIsNan<IssmDouble>(gl[0]));
+	_assert_(!xIsNan<IssmDouble>(gl[1]));
+	_assert_(!xIsNan<IssmDouble>(gl[2]));
+
+	/*Be sure that values are not zero*/
+	if(gl[0]==0.) gl[0]=gl[0]+epsilon;
+	if(gl[1]==0.) gl[1]=gl[1]+epsilon;
+	if(gl[2]==0.) gl[2]=gl[2]+epsilon;
+
+	/*Check that not all nodes are positive or negative: */
+	if(gl[0]>0 && gl[1]>0 && gl[2]>0){ // All positive
+		point=0;
+		f1=1.;
+		f2=1.;
+	}
+	else if(gl[0]<0 && gl[1]<0 && gl[2]<0){ //All negative
+		point=0;
+		f1=0.;
+		f2=0.;
+	}
+	else{
+		if(gl[0]*gl[1]*gl[2]<0) trapezeisnegative=false; //no matter what configuration, there has to be two positive vertices, which means the trapeze is positive.
+
+		if(gl[0]*gl[1]>0){ //Nodes 0 and 1 are similar, so points must be found on segment 0-2 and 1-2
+			point=2;
+			f1=gl[2]/(gl[2]-gl[0]);
+			f2=gl[2]/(gl[2]-gl[1]);
+		}
+		else if(gl[1]*gl[2]>0){ //Nodes 1 and 2 are similar, so points must be found on segment 0-1 and 0-2
+			point=0;
+			f1=gl[0]/(gl[0]-gl[1]);
+			f2=gl[0]/(gl[0]-gl[2]);
+		}
+		else if(gl[0]*gl[2]>0){ //Nodes 0 and 2 are similar, so points must be found on segment 1-0 and 1-2
+			point=1;
+			f1=gl[1]/(gl[1]-gl[2]);
+			f2=gl[1]/(gl[1]-gl[0]);
+		}
+		else _error_("case not possible");
+	}
+	if(trapezeisnegative) phi=1-f1*f2;
+	else phi=f1*f2;
+
+	/*Compute weights:*/
+	gauss = this->NewGauss(point,f1,f2,1-trapezeisnegative,2); //VV correction (16Nov2021)
+
+	total_weight=0;
+	for(int i=0;i<NUMVERTICES;i++)weights[i]=0;
+	while(gauss->next()){
+		TriaRef::GetNodalFunctions(&loadweights_g[0], gauss,P1Enum);
+		for(int i=0;i<NUMVERTICES;i++)weights[i]+=loadweights_g[i]*gauss->weight;
+		total_weight+=gauss->weight;
+	}
+	/*Normalizing to phi such that weights provide coefficients for integration over subelement (for averaging:phi*weights)*/  
+	if(total_weight>0.) for(int i=0;i<NUMVERTICES;i++)weights[i]/=total_weight/phi; 
+	else for(int i=0;i<NUMVERTICES;i++)weights[i]=0;
+
+	/*free ressources:*/
+	delete gauss;
+
+	/*Assign output pointers:*/
+	*pphi=phi;
+	*ppoint1=point;
+	*pfraction1=f1;
+	*pfraction2=f2;
+	*ptrapezeisnegative=trapezeisnegative;
+}
+/*}}}*/
+IssmDouble Tria::GetTriangleAreaSpherical(IssmDouble xyz_list[3][3]){/*{{{*/
+
+	IssmDouble x1,y1,z1,x2,y2,z2,x3,y3,z3;
+	IssmDouble arc12,arc23,arc31,semi_peri,excess;
+	IssmDouble lat1,lat2,lat3;
+	IssmDouble long1,long2,long3;
+	IssmDouble r1,r2,r3;
+
+	/*retrieve x,y,z coordinates: */
+	x1=xyz_list[0][0]; y1=xyz_list[0][1]; z1=xyz_list[0][2];
+	x2=xyz_list[1][0]; y2=xyz_list[1][1]; z2=xyz_list[1][2];
+	x3=xyz_list[2][0]; y3=xyz_list[2][1]; z3=xyz_list[2][2];
+
+	/*Build lat,long, r:*/
+	r1=sqrt(pow(x1,2.0)+pow(y1,2.0)+pow(z1,2.0));
+	r2=sqrt(pow(x2,2.0)+pow(y2,2.0)+pow(z2,2.0));
+	r3=sqrt(pow(x3,2.0)+pow(y3,2.0)+pow(z3,2.0));
+
+	lat1=asin(z1/r1); long1=atan2(y1,x1);
+	lat2=asin(z2/r2); long2=atan2(y2,x2);
+	lat3=asin(z3/r3); long3=atan2(y3,x3);
+
+	/*compute great circle distance between vertices */
+	arc12=2.*asin(sqrt(pow(sin(0.5*(lat2-lat1)),2)+cos(lat1)*cos(lat2)*pow(sin(0.5*(long2-long1)),2)));
+	arc23=2.*asin(sqrt(pow(sin(0.5*(lat3-lat2)),2)+cos(lat2)*cos(lat3)*pow(sin(0.5*(long3-long2)),2)));
+	arc31=2.*asin(sqrt(pow(sin(0.5*(lat1-lat3)),2)+cos(lat3)*cos(lat1)*pow(sin(0.5*(long1-long3)),2)));
+
+	/*semi parameter */
+	semi_peri=(arc12+arc23+arc31)/2;
+
+	/*spherical excess */
+	excess=4.*atan(sqrt(tan(semi_peri/2)*tan((semi_peri-arc12)/2)*tan((semi_peri-arc23)/2)*tan((semi_peri-arc31)/2)));
+
+	/*area = excess*radius^2 */
+	return excess*pow((r1+r2+r3)/3,2);
+}
+/*}}}*/
+void       Tria:: GetBarycenterFromLevelset(IssmDouble* platbar, IssmDouble* plongbar,IssmDouble phi,IssmDouble fraction1,IssmDouble fraction2,IssmDouble late, IssmDouble longe, int point1,int istrapeze1, IssmDouble planetradius){ /*{{{*/
+
+	int i0,i1,i2;
+
+	IssmDouble xyz0[3][3];
+	IssmDouble barycenter[3]={0};
+	IssmDouble centroid[3]={0};
+
+	::GetVerticesCoordinates(&xyz0[0][0],vertices,NUMVERTICES); // initial triangle
+
+	i0=point1;
+	i1=(point1+1)%3;
+	i2=(point1+2)%3;
+
+	//Barycenter of the subelement triangle:
+	for (int i=0;i<3;i++) barycenter[i]=xyz0[i0][i]*(3.0-fraction1-fraction2)/3.0 + fraction1/3.0*xyz0[i1][i] + fraction2/3.0*xyz0[i2][i];
+
+	if (istrapeze1){
+		centroid[0]=planetradius*cos(late*M_PI/180.0) * cos(longe*M_PI/180.0); //x
+		centroid[1]=planetradius*cos(late*M_PI/180.0) * sin(longe*M_PI/180.0);  //y
+		centroid[2]=planetradius*sin(late*M_PI/180.0);					//z
+
+		// centroid_el *area_el= barycenter_triangle * area_triangle + barycenter_trapeze * area_trapeze
+		// and phi_trapeze = area_trapeze/area_el = (1 - area_triangle/area_el)
+		// => barycenter_trapeze = (centroid_el - barycenter_triangle * (1-phi_trapeze) )/phi_trapeze
+		for (int i=0;i<3;i++) barycenter[i] =(centroid[i] -barycenter[i]*(1.0-phi))/phi;
+
+	}
+
+	//recompute planetradius from the barycenter onwards:
+	planetradius=sqrt( pow(barycenter[0],2.0)+ pow(barycenter[1],2.0)+ pow(barycenter[2],2.0));
+
+	*platbar=asin(barycenter[2]/planetradius)*180.0/M_PI;
+	*plongbar=atan2(barycenter[1],barycenter[0])*180.0/M_PI;
+
+} /*}}}*/
+void       Tria::GetNodalWeightsAndAreaAndCentroidsFromLeveset(IssmDouble* loadweights, IssmDouble* ploadarea, IssmDouble* platbar, IssmDouble* plongbar, IssmDouble late, IssmDouble longe, IssmDouble area,  int levelsetenum){ /*{{{*/
+
+	IssmDouble phi;
+	IssmDouble fraction1,fraction2;
+	bool istrapeze1;  
+	bool flip1=false;
+	int  point1;
+	IssmDouble levelset[NUMVERTICES];
+	IssmDouble planetradius;
+
+	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
+
+	//figure out if we are flipping the levelsets: 
+	if(levelsetenum<0){
+		levelsetenum=-levelsetenum;
+		flip1=true;
+	}
+	//figure out area where we have loads
+	Element::GetInputListOnVertices(&levelset[0],levelsetenum);
+	if(flip1)for(int i=0;i<NUMVERTICES;i++)levelset[i]=-levelset[i];
+
+	//compute sea level load weights
+	this->GetFractionGeometry(loadweights,&phi,&point1,&fraction1,&fraction2,&istrapeze1,levelset);
+
+	this->GetBarycenterFromLevelset(platbar,plongbar, phi, fraction1, fraction2, late, longe, point1,istrapeze1,planetradius);
+
+	/*assign output pointers:*/
+	*ploadarea=phi*area;
+
+} /*}}}*/
+void       Tria::GetNodalWeightsAndAreaAndCentroidsFromLeveset(IssmDouble* loadweights, IssmDouble* ploadarea, IssmDouble* platbar, IssmDouble* plongbar, IssmDouble late, IssmDouble longe, IssmDouble area,  int levelset1enum, int levelset2enum){ /*{{{*/
+
+	bool istrapeze1, istrapeze2;
+	IssmDouble phi1,phi2, d,e,f,g,h1,h2;
+	int point1, point2,  i0,i1,i2,j0,j1,j2;
+	IssmDouble weights1[3],weights2[3];
+	IssmDouble levelset1[3];
+	IssmDouble levelset2[3];
+
+	bool flip1=false;
+	bool flip2=false;
+
+	IssmDouble xyz0[3][3];
+	IssmDouble xyz1[3][3]={0};
+	IssmDouble xyz2[3][3]={0};
+	IssmDouble xyz3[3][3]={0};
+	IssmDouble xyz[8][3]={0};
+	IssmDouble w[8][NUMVERTICES]={0};
+	IssmDouble areasub=0;
+	IssmDouble area1=0;
+	IssmDouble area2=0;
+	IssmDouble area3=0;
+
+	int tria0[3]={0,1,2};
+	int tria1[3]={-1};
+	int tria2[3]={-1};
+	int tria3[3]={-1};
+
+	IssmDouble w1[3][3]={0};
+	IssmDouble w2[3][3]={0};
+	IssmDouble w3[3][3]={0};
+
+	IssmDouble barycenter[3]={0};
+	IssmDouble planetradius;
+
+	//figure out if we are flipping the levelsets: 
+	if(levelset1enum<0){
+		levelset1enum=-levelset1enum;
+		flip1=true;
+	}
+	if(levelset2enum<0){
+		levelset2enum=-levelset2enum;
+		flip2=true;
+	}
+
+	//recover levelsets: 
+	Element::GetInputListOnVertices(&levelset1[0],levelset1enum);
+	if(flip1)for(int i=0;i<NUMVERTICES;i++)levelset1[i]=-levelset1[i];
+	Element::GetInputListOnVertices(&levelset2[0],levelset2enum);
+	if(flip2)for(int i=0;i<NUMVERTICES;i++)levelset2[i]=-levelset2[i];
+
+	//We want the fraction of the element where both levelsets are negative.
+	//Early return if either of them is >=0 on all vertices
+	if (levelset1[0]>=0 && levelset1[1]>=0 && levelset1[2]>=0) {
+		for (int i=0;i<NUMVERTICES;i++) loadweights[i]=0.0;
+		*ploadarea= 0.0;
+		*platbar=late; //just default to centroid of triangle
+		*plongbar=longe; 
+		return;
+	}
+	if (levelset2[0]>=0 && levelset2[1]>=0 && levelset2[2]>=0) {
+		for (int i=0;i<NUMVERTICES;i++) loadweights[i]=0.0;
+		*ploadarea= 0.0;
+		*platbar=late; //just default to centroid of triangle
+		*plongbar=longe; 
+		return;
+	}
+
+	//If everyone is negative, no need to calculate any fraction
+	if (levelset1[0]<=0 && levelset1[1]<=0 && levelset1[2]<=0 && levelset2[0]<=0 && levelset2[1]<=0 && levelset2[2]<=0) {
+		for (int i=0;i<NUMVERTICES;i++) loadweights[i]=1.0/NUMVERTICES;
+		*ploadarea= area;
+		*platbar=late;
+		*plongbar=longe;
+		return;
+	}
+
+	/*recover planet radius:*/
+	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
+
+	//If just one levelset is all negative, just take the partitioning of the other, no interaction between them
+	if (levelset1[0]<=0 && levelset1[1]<=0 && levelset1[2]<=0) {
+		this->GetFractionGeometry(loadweights,&phi2,&point2,&f,&g,&istrapeze2,levelset2);
+		this->GetBarycenterFromLevelset(platbar,plongbar, phi2, f, g, late, longe, point2,istrapeze2,planetradius);
+		*ploadarea=area*phi2;
+		return;
+	}
+	if (levelset2[0]<=0 && levelset2[1]<=0 && levelset2[2]<=0) {
+		this->GetFractionGeometry(loadweights,&phi1,&point1,&d,&e,&istrapeze1,levelset1);
+		this->GetBarycenterFromLevelset(platbar,plongbar, phi1, d, e, late, longe, point1,istrapeze1,planetradius);
+		*ploadarea=area*phi1;
+		return;
+	}
+
+	this->GetFractionGeometry(&weights1[0],&phi1,&point1,&d,&e,&istrapeze1,levelset1);
+	this->GetFractionGeometry(&weights2[0],&phi2,&point2,&f,&g,&istrapeze2,levelset2);
+
+	//Early return if levelsets are not independent
+	if (istrapeze1==istrapeze2 && point1==point2 && phi1==phi2){
+		//the two levelsets are redundant: levelset1 = positivescalar * levelset2
+		this->GetBarycenterFromLevelset(platbar,plongbar, phi1, d, e, late, longe, point1,istrapeze1,planetradius);
+		*ploadarea=area*phi1;
+		for (int i=0;i<NUMVERTICES;i++) loadweights[i]=weights1[i];
+		return;
+	}
+	if (istrapeze1!=istrapeze2 && point1==point2 && phi1==(1.0-phi2)){
+		//the two levelsets are incompatible: levelset1 = negativescalar * levelset2
+		*plongbar=longe;
+		*platbar=late;
+		*ploadarea=0.0;
+		for (int i=0;i<NUMVERTICES;i++) loadweights[i]=0.0;
+		return;
+	}
+
+	::GetVerticesCoordinates(&xyz0[0][0],vertices,NUMVERTICES); // initial triangle
+
+	//Let our element be triangle ABC with:
+	i0=point1; //A
+	i1=(point1+1)%3; //B
+	i2=(point1+2)%3; //C
+
+	j0=point2; //Can be A, B or C
+	j1=(point2+1)%3; //anticlockwise point from j0
+	j2=(point2+2)%3; //clockwise point from j0
+
+	/* Below we define the relative fractional lengths of ABC where the zero-level contours of the two level sets intersect with ABC and each other. For example D is the intersection of level set 1 with side AB with fractional length d=[AD]/[AB].
+
+	   levelset1 intersects ABC on D and E:
+	   A------D---B
+	   <--d--->		
+
+	   A-----E----C
+	   <--e-->
+
+	   levelset2 intersects ABC on F and G:
+	   j0---F------j1
+	   <--f->
+
+	   j0-------G--j2
+	   <---g---->
+
+	   levelset1 and 2 intersect on H (when that intersection exists inside the element)
+	   D----H------E
+	   <-h1->
+
+	   F-----H----G
+	   <--h2->
+	*/
+
+	if (point2==i0){
+		h1= g*(d-f)/(d*g-e*f);
+		h2= e/g * h1;
+	}
+        else if (point2==i1){
+		h1=f*(1.0-g-d)/(f*(e-d)-e*g);
+		h2= 1.0-e/f * h1;
+	}
+	else if (point2==i2){
+		h1= (g*(1.0-f-d)+f*d)/(g*(e-d) +f*d); 
+		h2= (d*(f+e-1))/(g*(e-d) +f*d);
+	}
+
+	//interpolant weights of each point. Any field F[0,1,2] provided at the original vertices [0,1,2] will be equal on point k to sum_i (F[i] * w[k][i])
+	w[0][0]=1; //A
+	w[1][1]=1; //B
+	w[2][2]=1; //C
+	w[3][i0]=1.0-d; w[3][i1]=d; //D
+	w[4][i0]=1.0-e; w[4][i2]=e; //E
+	w[5][j0]=1.0-f; w[5][j1]=f; //F
+	w[6][j0]=1.0-g; w[6][j2]=g; //G
+	for (int j=0;j<3;j++) w[7][j]=w[3][j]*(1.0-h1) + w[4][j]*h1; //H: we interpolate the intersection point H between D and E at fraction h1
+
+	for (int k=0;k<8;k++){
+		for (int i=0;i<NUMVERTICES;i++) {
+			for (int j=0;j<3;j++) xyz[k][j]+=xyz0[i][j]*w[k][i];
+		}
+	}
+
+		//point2 can be either i0,i1 or i2. We start the search with i1 and i2 as they have less computational cost in ifs
+		if(point2==i2){ /*{{{*/
+			if (e>1.0-f){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+					tria1[0]=5; tria1[1]= 7; tria1[2]= 4; // FHE
+					area1=h2*(e+f-1.0)*g;
+				}
+				else if (!istrapeze1 && istrapeze2){
+					tria1[0]=i0; tria1[1]= 3; tria1[2]= 5; //ADF
+					area1=d*(1.0-f);
+					tria2[0]=3; tria2[1]= 7; tria2[2]= 5; //DHF
+					area2=d*h1*(e+f-1.0);
+				}
+				else if (istrapeze1 && !istrapeze2){
+					tria1[0]=7; tria1[1]= 6; tria1[2]= 4; //HGE
+					area1=g*(1.0-h2)*(e+f-1.0);
+					tria2[0]=4; tria2[1]= 6; tria2[2]= i2; //EGC
+					area2=g*(1.0-e);
+				}
+				else { //istrapeze1 && istrapeze2
+					tria1[0]=3; tria1[1]= i1; tria1[2]= 6; //DBG
+					area1=(1.0-d)*(1.0-g);
+					tria2[0]=3; tria2[1]= 6; tria2[2]= 7; //DGH
+					area2=g*((1.0-f)*(1.0-h2)+h2*e)+d*(1.0-e-g);
+				}  /*}}}*/
+			}
+			else if (e<=1.0-f){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+				}
+				else if (!istrapeze1 && istrapeze2){
+					tria1[0]=i0; tria1[1]= 3; tria1[2]= 4; //ADE
+					area1=d*e;
+				}
+				else if (istrapeze1 && !istrapeze2){
+					tria1[0]=5; tria1[1]= 6; tria1[2]= i2; //FGC
+					area1=f*g;
+				}
+				else { //istrapeze1 && istrapeze2
+					tria1[0]=3; tria1[1]= i1; tria1[2]= 5; //DBF
+			                area1=(1.0-d)*(1.0-f);
+					tria2[0]=4; tria2[1]= 3; tria2[2]= 5;  //EDF
+			                area2=d*(1.0-e-f);
+					tria3[0]=5; tria3[1]= i1; tria3[2]= 6; //FBG
+			                area3=f*(1.0-g);
+				} /*}}}*/
+			} 
+		}/*}}}*/    
+		else if(point2==i1){ /*{{{*/
+			if (d>1.0-g){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+					tria1[0]=6; tria1[1]= 3; tria1[2]= 7; //GDH
+					area1=(1.0-h2)*(d+g-1.0)*f;
+				}
+				else if (!istrapeze1 && istrapeze2){
+					tria1[0]=i0; tria1[1]= 6; tria1[2]= 4; //AGE
+			                area1=(1.0-g)*e;
+					tria2[0]=6; tria2[1]= 7; tria2[2]= 4; //GHE
+			                area2=e*(1.0-h1)*(g+d-1.0);
+				}
+				else if (istrapeze1 && !istrapeze2){
+					tria1[0]=i1; tria1[1]= 5; tria1[2]= 3; //BFD
+			                area1=(1.0-d)*f;
+					tria2[0]=3; tria2[1]= 5; tria2[2]= 7; //DFH
+					area2=f*h2*(d+g-1.0);
+				}
+				else { //istrapeze1 && istrapeze2
+					tria1[0]=7; tria1[1]= 5; tria1[2]= 4; //HFE
+			                area1=e*((1.0-d)*(1.0-h1)+h1*g)+f*(1.0-g-e);
+					tria2[0]=4; tria2[1]= 5; tria2[2]= i2;//EFC
+			                area2=(1.0-e)*(1.0-f);
+				}  /*}}}*/
+			}
+			else if (d<=1.0-g){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+				}
+				else if (!istrapeze1 && istrapeze2){
+					tria1[0]=i0; tria1[1]= 3; tria1[2]= 4; //ADE
+			                area1=d*e;
+				}
+				else if (istrapeze1 && !istrapeze2){
+					tria1[0]=6; tria1[1]= i1; tria1[2]= 5; //GBF
+			                area1=f*g;
+				}
+				else { //istrapeze1 && istrapeze2
+					tria1[0]=3; tria1[1]= 6; tria1[2]= 4; //DGE
+					area1=e*(1.0-d-g);
+					tria2[0]=6; tria2[1]= i2; tria2[2]= 4; //GCE
+					area2=(1.0-g)*(1.0-e);
+					tria3[0]=6; tria3[1]= 5; tria3[2]= i2; //GFC
+					area3=g*(1.0-f);
+				} /*}}}*/
+			}
+
+		}/*}}}*/
+		else{ /*{{{*/
+			if (d<=f && e>=g){  /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+					tria1[0]=i0; tria1[1]= 3; tria1[2]= 7; //ADH
+			                area1=h1*d*e;
+					tria2[0]=i0; tria2[1]= 7; tria2[2]= 6; //AHG
+			                area2=(1.0-h2)*f*g;
+				}
+				else if (!istrapeze1 && istrapeze2){
+					tria1[0]=6; tria1[1]= 7; tria1[2]= 4; //GHE
+			                area1=(e-g)*d*(1.0-h1);
+				}
+				else if (istrapeze1 && !istrapeze2){
+					tria1[0]=3; tria1[1]= 5; tria1[2]= 7; //DFH
+					area1=(f-d)*g*h2;
+				}
+				else { //istrapeze1 && istrapeze2
+					tria1[0]=5; tria1[1]= i1; tria1[2]= 7; //FBH
+			                area1=g*h2*(1.0-f);
+					tria2[0]=7; tria2[1]= i1; tria2[2]= i2;//HBC
+			                area2=1.0+d*(h1-e*h1-1.0)+g*h2*(d-1.0);
+					tria3[0]=7; tria3[1]= i2; tria3[2]= 4; //HCE
+			                area3=d*(1.0-h1)*(1.0-e);
+				} /*}}}*/
+			}
+			else if (d>=f && e<=g){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+					tria1[0]=i0; tria1[1]= 5; tria1[2]= 7; //AFH
+			                area1=h2*f*g;
+					tria2[0]=i0; tria2[1]= 7; tria2[2]= 4; //AHE
+			                area2=(1.0-h1)*d*e;
+				}else if (!istrapeze1 && istrapeze2){
+					tria1[0]=5; tria1[1]= 3; tria1[2]= 7; //FDH
+			                area1=(d-f)*e*h1;
+				}else if (istrapeze1 && !istrapeze2){
+					tria1[0]=4; tria1[1]= 7; tria1[2]= 6; //EHG
+			                area1=(g-e)*f*(1.0-h2);
+				}else { //istrapeze1 && istrapeze2
+					tria1[0]=3; tria1[1]= i1; tria1[2]= 7; //DBH
+			                area1=e*h1*(1.0-d);
+					tria2[0]=7; tria2[1]= i1; tria2[2]= 6; //HCG
+			                area2=f*(1.0-h2)*(1.0-g);
+					tria3[0]=6; tria3[1]= i1; tria3[2]= i2; //HBC
+			                area3=1.0+f*(h2-g*h2-1.0)+e*h1*(f-1.0);
+				}  /*}}}*/
+			}
+			else if (d<=f && e<=g){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+					tria1[0]=i0; tria1[1]= 3; tria1[2]= 4;//ADE
+					area1=d*e;
+				}else if (!istrapeze1 && istrapeze2){
+				}else if (istrapeze1 && !istrapeze2){
+					tria1[0]=3; tria1[1]= 5; tria1[2]= 6; //DFG
+			                area1=g*(f-d);
+					tria2[0]=3; tria2[1]= 6; tria2[2]= 4; //DGE
+			                area2=d*(g-e);
+				}else { //istrapeze1 && istrapeze2
+					tria1[0]=5; tria1[1]= i2; tria1[2]= 6; //FCG
+			                area1=f*(1.0-g);
+					tria2[0]=5; tria2[1]= i1; tria2[2]= i2;//FBC
+			                area2=1.0-f;
+				}  /*}}}*/
+			}
+			else if (d>=f && e>=g){ /*{{{*/
+				if (!istrapeze1 && !istrapeze2){
+					tria1[0]=i0; tria1[1]= 5; tria1[2]= 6; //AFG
+			                area1=f*g;
+				}else if (!istrapeze1 && istrapeze2){
+					tria1[0]=5; tria1[1]= 4; tria1[2]= 6; //FEG
+			                area1=f*(e-g);
+					tria2[0]=5; tria2[1]= 3; tria2[2]= 4; //FDE
+			                area2=e*(d-f);
+				}else if (istrapeze1 && !istrapeze2){
+				}else { //istrapeze1 && istrapeze2
+					tria1[0]=3; tria1[1]= i1; tria1[2]= i2; //DBC
+			                area1=1.0-d;
+					tria2[0]=3; tria2[1]= i2; tria2[2]= 4;//DCE
+			                area2=d*(1.0-e);
+				}  /*}}}*/
+			} 
+		} /*}}}*/
+
+	if(tria1[0]>-1){ 
+		for (int i=0;i<NUMVERTICES;i++){
+			for (int j=0;j<3;j++) {
+				xyz1[i][j]=xyz[tria1[i]][j];
+				w1[i][j]=w[tria1[i]][j];
+			}
+		}
+		area1*=area; //dimensionalize the fractional area from [0:1] to [0:area]
+	}
+	if(tria2[0]>-1){ 
+		for (int i=0;i<NUMVERTICES;i++){
+			for (int j=0;j<3;j++) {
+				xyz2[i][j]=xyz[tria2[i]][j];
+				w2[i][j]=w[tria2[i]][j];
+			}
+		}
+		area2*=area;
+	}
+	if(tria3[0]>-1){ 
+		for (int i=0;i<NUMVERTICES;i++){
+			for (int j=0;j<3;j++) {
+				xyz3[i][j]=xyz[tria3[i]][j];
+				w3[i][j]=w[tria3[i]][j];
+			}
+		}
+		area3*=area;
+	}
+
+	areasub=area1+area2+area3;
+
+	if (areasub>0){
+		for (int j=0;j<3;j++){
+			for (int i=0;i<NUMVERTICES;i++) {
+				loadweights[j]=w1[i][j]*area1 + w2[i][j]*area2 + w3[i][j]*area3;
+				barycenter[j]+=xyz1[i][j]*area1+xyz2[i][j]*area2+xyz3[i][j]*area3;
+			}
+			loadweights[j]/=area;
+			barycenter[j]/=areasub *3.0;
+		}
+		*platbar=asin(barycenter[2]/sqrt(pow(barycenter[0],2.0)+pow(barycenter[1],2.0)+pow(barycenter[2],2.0)))*180.0/M_PI;
+		*plongbar=atan2(barycenter[1],barycenter[0])*180.0/M_PI;
+	} 
+	else {
+		for(int j=0;j<3;j++)loadweights[j]=0.0;
+		*platbar=late;
+		*plongbar=longe;
+	}
+	*ploadarea=areasub;
+
+} /*}}}*/
 IssmDouble Tria::GetIcefrontArea(){/*{{{*/
 
@@ -1869,5 +2497,4 @@
 		TriaInput* input = this->inputs->GetTriaInput(inputenum);
 		if(!input) return input;
-
 		this->InputServe(input);
 		return input;
@@ -1977,4 +2604,5 @@
 				input->Serve(numindices,&indices[0]);
 				break;
+			case P1xP4Enum:
 			case P1DGEnum:
 			case P1bubbleEnum:
@@ -2143,4 +2771,5 @@
 
 	/*Assign output pointers*/
+	xDelete<IssmDouble>(timesteps);
 	*pvalues=values;
 	*ptimes=times;
@@ -2155,9 +2784,7 @@
 	int index = this->GetNodeIndex(node);
 
-	GaussTria* gauss=new GaussTria();
-	gauss->GaussNode(this->element_type,index);
-
-	input->GetInputValue(pvalue,gauss);
-	delete gauss;
+	GaussTria gauss;
+	gauss.GaussNode(this->element_type,index);
+	input->GetInputValue(pvalue,&gauss);
 }
 /*}}}*/
@@ -2169,9 +2796,7 @@
 	int index = this->GetVertexIndex(vertex);
 
-	GaussTria* gauss=new GaussTria();
-	gauss->GaussVertex(index);
-
-	input->GetInputValue(pvalue,gauss);
-	delete gauss;
+	GaussTria gauss;
+	gauss.GaussVertex(index);
+	input->GetInputValue(pvalue,&gauss);
 }
 /*}}}*/
@@ -2222,5 +2847,5 @@
 
 	/*Intermediaries*/
-	int i, numiceverts, numnoiceverts;
+	int numiceverts, numnoiceverts;
 	int ind0, ind1, lastindex;
 	int indices_ice[NUMVERTICES],indices_noice[NUMVERTICES];
@@ -2234,5 +2859,5 @@
 	 * Exploit: ice/no-ice parts are connected, so find starting vertex of segment*/
 	lastindex=0;
-	for(i=0;i<NUMVERTICES;i++){ // go backwards along vertices, and check for sign change
+	for(int i=0;i<NUMVERTICES;i++){ // go backwards along vertices, and check for sign change
 		ind0=(NUMVERTICES-i)%NUMVERTICES;
 		ind1=(ind0-1+NUMVERTICES)%NUMVERTICES;
@@ -2248,5 +2873,5 @@
 	numiceverts=0;
 	numnoiceverts=0;
-	for(i=0;i<NUMVERTICES;i++){
+	for(int i=0;i<NUMVERTICES;i++){
 		ind0=(lastindex+i)%NUMVERTICES;
 		if(lsf[i]<=level){
@@ -2260,24 +2885,28 @@
 	}
 	//merge indices
-	for(i=0;i<numiceverts;i++){indices[i]=indices_ice[i];}
-	for(i=0;i<numnoiceverts;i++){indices[numiceverts+i]=indices_noice[i];}
-
-	switch (numiceverts){
+	for(int i=0;i<numiceverts;  i++){
+		indices[i]=indices_ice[i];
+	}
+	for(int i=0;i<numnoiceverts;i++){
+		indices[numiceverts+i]=indices_noice[i];
+	}
+
+	switch(numiceverts){
 		case 0: // no vertex has ice: element is ice free, no intersection
-			for(i=0;i<2;i++)
+			for(int i=0;i<2;i++)
 				fraction[i]=0.;
 			break;
 		case 1: // one vertex has ice:
-			for(i=0;i<2;i++){
+			for(int i=0;i<2;i++){
 				fraction[i]=(level-lsf[indices[0]])/(lsf[indices[numiceverts+i]]-lsf[indices[0]]);
 			}
 			break;
 		case 2: // two vertices have ice: fraction is computed from first ice vertex to last in CCW fashion
-			for(i=0;i<2;i++){
+			for(int i=0;i<2;i++){
 				fraction[i]=(level-lsf[indices[i]])/(lsf[indices[numiceverts]]-lsf[indices[i]]);
 			}
 			break;
 		case NUMVERTICES: // all vertices have ice: return triangle area
-			for(i=0;i<2;i++)
+			for(int i=0;i<2;i++)
 				fraction[i]=1.;
 			break;
@@ -2860,4 +3489,5 @@
 	parameters->FindParam(&domaintype,DomainTypeEnum);
 
+	/*Relict code
 	if(false && IsIcefront()){
 		//Assumption: linear ice thickness profile on element.
@@ -2914,5 +3544,39 @@
 		for(i=0;i<numthk;i++)	Haverage+=H[i];
 		Haverage/=IssmDouble(numthk);
-	}
+	}*/
+
+   IssmDouble lsf[NUMVERTICES];
+	Element::GetInputListOnVertices(&lsf[0],MaskIceLevelsetEnum);
+   /*Deal with partially ice-covered elements*/
+	if(lsf[0]*lsf[1]<=0 || lsf[0]*lsf[2]<=0 || lsf[1]*lsf[2]<=0){
+		bool istrapneg;
+      int point;
+      IssmDouble weights[NUMVERTICES];
+      IssmDouble surfaces[NUMVERTICES];
+      IssmDouble bases[NUMVERTICES];
+      IssmDouble Hice[NUMVERTICES];
+      IssmDouble area_basetot,f1,f2,phi;
+      /*Average thickness over subelement*/
+		Element::GetInputListOnVertices(&surfaces[0],SurfaceEnum);
+      Element::GetInputListOnVertices(&bases[0],BaseEnum);
+      GetFractionGeometry(weights,&phi,&point,&f1,&f2,&istrapneg,lsf);
+      for(int i=0;i<NUMVERTICES;i++) Hice[i] = surfaces[i]-bases[i];
+      Haverage = 0.0;
+		/*Use weights[i]/phi to get average thickness over subelement*/
+      for(int i=0;i<NUMVERTICES;i++) Haverage += weights[i]/phi*Hice[i];
+		/*Get back area of ice-covered base*/
+		area_basetot = this->GetArea();
+		area_base    = phi*area_basetot;
+
+		/*Account for scaling factor averaged over subelement*/
+		if(scaled==true){
+			IssmDouble* scalefactor_vertices = xNew<IssmDouble>(NUMVERTICES);
+			Element::GetInputListOnVertices(&scalefactor_vertices[0],MeshScaleFactorEnum);
+			scalefactor = 0.0;
+			for(int i=0;i<NUMVERTICES;i++) scalefactor += weights[i]/phi*scalefactor_vertices[i];
+			area_base = area_base*scalefactor;
+			xDelete<IssmDouble>(scalefactor_vertices);
+		}
+   }
 	else{
 		/*First get back the area of the base*/
@@ -2932,4 +3596,5 @@
 	}
 
+	
 	/*Cleanup & return: */
 	xDelete<int>(indices);
@@ -2952,5 +3617,5 @@
 	IssmDouble xyz_list[NUMVERTICES][3];
 
-	if(!IsIceInElement() || IsFloating())return 0;
+	if(!IsIceInElement() || IsAllFloating())return 0;
 
 	rho_ice=FindParam(MaterialsRhoIceEnum);
@@ -3257,18 +3922,10 @@
 
 	/*intermediary: */
-	IssmDouble* values=NULL;
-	Input*     thickness_input=NULL;
 	IssmDouble  thickness;
-	IssmDouble  weight;
 	IssmDouble  Jdet;
-	IssmDouble  volume;
-	IssmDouble  rho_ice;
 	int         point1;
 	IssmDouble  fraction1,fraction2;
 	bool        mainlynegative=true;
 
-	/*Output:*/
-	volume=0;
-
 	/* Get node coordinates and dof list: */
 	IssmDouble  xyz_list[NUMVERTICES][3];
@@ -3276,11 +3933,11 @@
 
 	/*Retrieve inputs required:*/
-	thickness_input=this->GetInput(ThicknessEnum); _assert_(thickness_input);
+	Input* thickness_input=this->GetInput(ThicknessEnum); _assert_(thickness_input);
 
 	/*Retrieve material parameters: */
-	rho_ice=FindParam(MaterialsRhoIceEnum);
+	IssmDouble rho_ice=FindParam(MaterialsRhoIceEnum);
 
 	/*Retrieve values of the levelset defining the masscon: */
-	values = xNew<IssmDouble>(NUMVERTICES);
+	IssmDouble values[NUMVERTICES];
 	for(int i=0;i<NUMVERTICES;i++){
 		values[i]=levelset[this->vertices[i]->Sid()];
@@ -3288,19 +3945,15 @@
 
 	/*Ok, use the level set values to figure out where we put our gaussian points:*/
-	this->GetLevelsetPositivePart(&point1,&fraction1,&fraction2,&mainlynegative,values);
+	this->GetLevelsetPositivePart(&point1,&fraction1,&fraction2,&mainlynegative,&values[0]);
 	Gauss* gauss = this->NewGauss(point1,fraction1,fraction2,mainlynegative,4);
 
-	volume=0;
-
+	IssmDouble volume=0.;
 	while(gauss->next()){
-
 		this->JacobianDeterminant(&Jdet,&xyz_list[0][0],gauss);
 		thickness_input->GetInputValue(&thickness, gauss);
-
 		volume+=thickness*gauss->weight*Jdet;
 	}
 
 	/* clean up and Return: */
-	xDelete<IssmDouble>(values);
 	delete gauss;
 	return rho_ice*volume;
@@ -3324,8 +3977,8 @@
 
 	/*get area coordinates of 0 and 1 locations: */
-	GaussTria* gauss_1=new GaussTria();
-	gauss_1->GaussFromCoords(x1,y1,&xyz_list[0][0]);
-	GaussTria* gauss_2=new GaussTria();
-	gauss_2->GaussFromCoords(x2,y2,&xyz_list[0][0]);
+	GaussTria gauss_1;
+	gauss_1.GaussFromCoords(x1,y1,&xyz_list[0][0]);
+	GaussTria gauss_2;
+	gauss_2.GaussFromCoords(x2,y2,&xyz_list[0][0]);
 
 	/*Get segment length and normal (needs to be properly oriented)*/
@@ -3348,10 +4001,10 @@
 	}
 
-	thickness_input->GetInputValue(&h1, gauss_1);
-	thickness_input->GetInputValue(&h2, gauss_2);
-	vx_input->GetInputValue(&vx1,gauss_1);
-	vx_input->GetInputValue(&vx2,gauss_2);
-	vy_input->GetInputValue(&vy1,gauss_1);
-	vy_input->GetInputValue(&vy2,gauss_2);
+	thickness_input->GetInputValue(&h1, &gauss_1);
+	thickness_input->GetInputValue(&h2, &gauss_2);
+	vx_input->GetInputValue(&vx1,&gauss_1);
+	vx_input->GetInputValue(&vx2,&gauss_2);
+	vy_input->GetInputValue(&vy1,&gauss_1);
+	vy_input->GetInputValue(&vy2,&gauss_2);
 
 	mass_flux= rho_ice*length*(
@@ -3361,6 +4014,4 @@
 
 	/*clean up and return:*/
-	delete gauss_1;
-	delete gauss_2;
 	return mass_flux;
 }
